package net.wanji.utc.service.rpc;

import net.wanji.utc.entity.JsonViewObject;
import net.wanji.utc.util.HttpRestUtil;

import java.util.Map;
import java.util.Objects;

/**
 * @author duanruiming
 * @date 2023/01/09 9:57
 */
public interface RpcService {

    /**
     * 远程调用信号机设备
     * @param url
     * @param headers
     * @param param
     * @return
     */
    default JsonViewObject rpcService(HttpRestUtil httpRestUtil, String url, Map<String, String> headers, String param) {
        JsonViewObject jsonViewObject = httpRestUtil.doPost(url, headers, param, JsonViewObject.class);
        if (Objects.isNull(jsonViewObject) || jsonViewObject.getCode() != 200) {
            return jsonViewObject.fail("远程服务调用异常，url:".concat(url));
        }
        return jsonViewObject;
    }
}
