package net.wanji.utc.service.runninginfo.impl;

import com.alibaba.fastjson.JSONObject;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import net.wanji.utc.entity.JsonViewObject;
import net.wanji.utc.po.SignalStatusLogPO;
import net.wanji.utc.service.runninginfo.WanJiCommonRunningStatusService;
import net.wanji.utc.util.HttpRestUtil;
import net.wanji.utc.vo.LightsStatusVO;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * @author duanruiming
 * @date 2023/01/11 17:34
 */
@Slf4j
@Service
@RequiredArgsConstructor
public class WanJiCommonRunningStatusServiceImpl implements WanJiCommonRunningStatusService {

    private final HttpRestUtil httpRestUtil;
    @Value("url")
    private String rpcUri;

    @Override
    public List<SignalStatusLogPO> runningStatus(List<String> crossIdList) {
        JsonViewObject jsonViewObject = rpcService(httpRestUtil, rpcUri, null, JSONObject.toJSONString(crossIdList));
        List<SignalStatusLogPO> result = (List<SignalStatusLogPO>) jsonViewObject.getContent();
        return result;
    }

    @Override
    public List<LightsStatusVO> lightsStatus(List<String> crossIdList) {
        JsonViewObject jsonViewObject = rpcService(httpRestUtil, rpcUri, null, JSONObject.toJSONString(crossIdList));
        List<LightsStatusVO> result = (List<LightsStatusVO>) jsonViewObject.getContent();
        return result;
    }

    @Override
    public JsonViewObject rpcService(HttpRestUtil httpRestUtil, String url, Map<String, String> headers, String param) {
        return WanJiCommonRunningStatusService.super.rpcService(httpRestUtil, url, headers, param);
    }
}
